// passed from GUIDistVis into Chunk, so Chunk doesn't need to
// know about pixel formats and GUIDistVis doesn't need to know
// about Chunk diff storage.

// This should be an abstract base class, esp. if we 
// need multiple implementations.

// perhaps set_diff should be declared in the header as
// inline.  (Somewhat incompatible w/ above, unless compiler
// passes class descriptors instead of vtables like GNU SmallEiffel.)
// Alternately, we could get set_diff inlined by templatizing
// diffs_to_pixels.

#include <glib.h>

class DiffStore {
public:
  DiffStore (guchar *p, unsigned int len);
  ~DiffStore ();
  void set_len (unsigned int len); // must call set_len b/f any set_diff

  bool set_diff (unsigned int which, float f, unsigned int j);
  // set_diff returns true if should continue.
  // set_diff is presented w/ distances in increasing and contiguous
  // j-order (beginning w/ 0, ending w/ len - 1 as set by set_len).
private:
  guchar *pix;
  unsigned int len;
  unsigned char *colors_map; // just dist to RGB vals
  float last_f;
  int  last_j;
};
