#include <set>

#include <gtk--/main.h>
#include <gtk--/window.h>
#include <gtk--/box.h>
#include <gtk--/adjustment.h>
#include <gtk--/spinbutton.h>
#include <gtk--/checkbutton.h>
#include <gtk--/radiobutton.h>
#include <gtk--/label.h>
#include "rgbinit.h"

#include "player.h"

#include "vis.h"

#include <set>
class GUIPlayer:public Player, public PlayParm, public Gtk::Main {
 public:
  GUIPlayer(int *argc, char ***argv, Samples *s, SoundPlayer *sp);
  virtual void run ();
  void add_vis (Vis *v);
  virtual void set_chunk (unsigned int chunk);
  virtual void set_max_age (int age);
  virtual int get_max_age ();
  virtual int get_age_of_chunk (unsigned int chunk);
  virtual int get_prev (unsigned int chunk);
 protected:
  float get_jump_probability ();

 private:
  set<Vis *> visualizer_set;
  GdkRgbInit gri;
  Gtk::Window mainwnd;
  Gtk::VBox vbox;
  Gtk::HBox hbox;
  void write_ready (gint src, GdkInputCondition condition);
  size_t bytes_left;
  Gtk::Label jump_prob_text;
  Gtk::SpinButton jump_prob_spin;
  Gtk::CheckButton wander_check_button;
  gint wander_timeout ();
  Gtk::HBox transition_alg_hbutton_box;
  Gtk::RadioButton *transition_alg_radio_buttons;
  void transition_alg_toggled (int alg);
  Gtk::Button recompute_button;
  void recompute ();
  struct tag_labelledSpinButton {
    Gtk::HBox box;
    Gtk::Label text;
    Gtk::SpinButton spin;
  } spins [3];
  static const unsigned int echo_len_ind = 0;
  static const unsigned int echo_amp_ind = 1;
  static const unsigned int chunk_dur_ind = 2;
  static const unsigned int max_ind = 3;
};

#include "visfact.h"













