
class Player {
public:
  Player (Samples *s, SoundPlayer *sp);
  virtual ~Player ();

protected:
  virtual void run ();
  void clear_hist ();
  Samples *samp;
  SoundPlayer *sound;

  unsigned int n_played;
  unsigned int cur_playing; // which chunk are we playing right now
  virtual float get_jump_probability ();

  static const int transition_alg_count;
  static char *transition_alg_names [];
  int transition_alg;
  void calc_next ();

  typedef std::map<unsigned int, unsigned int> ttc_map;
  ttc_map time_to_chunk;
  // XXX be careful about wrapping.

  vector<unsigned int> play_times;
  // only contains times which have actually played.

  vector<int> prev_chunk;  // for each played chunk, maps to
  // the chunk that preceeded it (or -1 for chunk not played or 
  // first chunk played.

  size_t max_chunks_buf_in_OSS;
  unsigned int max_age;
};
